classification
Title: asyncio.subprocess's communicate() method mishandles empty input bytes
Type: behavior Stage: resolved
Components: asyncio Versions: Python 3.6, Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: berker.peksag, gvanrossum, oconnor663, python-dev, vstinner, yselivanov
Priority: normal Keywords:

Created on 2016-04-26 04:40 by oconnor663, last changed 2016-05-14 01:42 by berker.peksag. This issue is now closed.

Messages (5)
msg264212 - (view) Author: Jack O'Connor (oconnor663) * Date: 2016-04-26 04:40
Setting stdin=PIPE and then calling communicate(b"") should close the child's stdin immediately, similar to stdin=DEVNULL. Instead, communicate() treats b"" like None and leaves the child's stdin open, which makes the child hang forever if it tries to read anything.

I have a PR open with a fix and a test: https://github.com/python/cpython/pull/33
msg264213 - (view) Author: Berker Peksag (berker.peksag) * (Python committer) Date: 2016-04-26 04:59
python/cpython is a semi-official read-only mirror of hg.python.org/cpython. We haven't switched to GitHub yet. You may want to open a pull request to https://github.com/python/asyncio See https://github.com/python/asyncio/wiki/Contributing for details.
msg264214 - (view) Author: Jack O'Connor (oconnor663) * Date: 2016-04-26 05:24
Thanks for the heads up, Berker, I've re-submitted the PR as https://github.com/python/asyncio/pull/335.
msg264215 - (view) Author: Jack O'Connor (oconnor663) * Date: 2016-04-26 05:25
Related: The asyncio communicate() method differs from standard subprocess in how it treats input bytes when stdin is (probably mistakenly) not set to PIPE. Like this:

    proc = await create_subprocess_shell("sleep 5")
    await proc.communicate(b"foo")  # Oops, I forgot stdin=PIPE above!

The standard, non-async version of this example, communicate would ignore the input bytes entirely. But here in the asyncio version, communicate will try to write those bytes to stdin, which is None, and the result is an AttributeError.

Since the user probably only hits this case by mistake, I think raising an exception is preferable. But it would be nice to raise an exception that explicitly said "you've forgotten stdin=PIPE" instead of the unhelpful "'NoneType' object has no attribute 'write'". Maybe it would be worth cleaning this up while we're here?
msg265487 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2016-05-13 19:39
New changeset 148757a88f19 by Yury Selivanov in branch '3.5':
Issue #26848: Fix asyncio/subprocess.communicate() to handle empty input.
https://hg.python.org/cpython/rev/148757a88f19

New changeset f5e69e2f50d7 by Yury Selivanov in branch 'default':
Merge 3.5 (issue #26848)
https://hg.python.org/cpython/rev/f5e69e2f50d7
History
Date User Action Args
2016-05-14 01:42:18berker.peksagsetstatus: open -> closed
resolution: fixed
stage: resolved
2016-05-13 19:39:18python-devsetnosy: + python-dev
messages: + msg265487
2016-04-26 05:25:15oconnor663setmessages: + msg264215
2016-04-26 05:24:35oconnor663setmessages: + msg264214
2016-04-26 04:59:55berker.peksagsetnosy: + berker.peksag
messages: + msg264213
2016-04-26 04:40:33oconnor663create